----------------------------------------------------------------
-- Binary Montgomery Product (_binary_Montgomery_product.adb)
-- 
-- A simple example of
-- MP(x,y) = x.y/R mod M
-- using the binary algorithm
----------------------------------------------------------------
with Gnat.Io; use Gnat.Io;
procedure binary_Montgomery_multiplication is
   K: constant Natural := 8;
   M: constant := 239;
   X, Y, P, Q, Z, A: Natural;
   type Vector is array(0 .. K-1) of Natural;
   Vector_X: Vector;
begin
   loop
         
      Put("x = "); Get(X); 
      Put("y = "); Get(Y);
        
      Q := X;
      for I in 0 .. K-1 loop Vector_X(I) := Q mod 2; Q := Q/2; end loop;
      ---------------------------------------------------------------------
      P := 0;
      for I in 0 .. K-1 loop
         A := P + Vector_X(I)*Y;
         P := (A + (A mod 2)*M)/2;         
      end loop;
      if P >= M then Z := P-M; else Z := P; end if;
      ----------------------------------------------------------------------
      Put("MP(");Put(X); Put(","); Put(Y); Put(") = "); Put(Z); New_Line;
   end loop;
end binary_Montgomery_multiplication;

