--------------------------------------------------------------------------------
-- 
-- VHDL Test Bench for module: mod_239_multiplier.vhd
--
-- Executes an exhaustive Test Bench.
--
--------------------------------------------------------------------------------
LIBRARY ieee;
USE ieee.std_logic_1164.ALL;
USE IEEE.std_logic_arith.all;
USE ieee.std_logic_signed.all;
USE ieee.std_logic_unsigned.all;
USE ieee.numeric_std.ALL;
USE ieee.std_logic_textio.ALL;
USE std.textio.ALL;


ENTITY test_mod239_mult IS
END test_mod239_mult;

ARCHITECTURE behavior OF test_mod239_mult IS 

  -- Component Declaration for the Unit Under Test (UUT)
  COMPONENT mod_239_multiplier
  PORT(
    x,y : in std_logic_vector(7 downto 0);
    z: out std_logic_vector(7 downto 0)
    );
  END COMPONENT;

  --Inputs
  SIGNAL x, y :  std_logic_vector(7 downto 0) := (others=>'0');
  --Outputs
  SIGNAL z :  std_logic_vector(7 downto 0);

  constant DELAY : time := 100 ns;

BEGIN

  -- Instantiate the Unit Under Test (UUT)
  uut: mod_239_multiplier PORT MAP(x => x, y => y, z => z );

  tb_proc : PROCESS --generate values
    VARIABLE TX_LOC : LINE;
    VARIABLE TX_STR : String(1 to 4096);
    BEGIN
      for J in 0 to 238 loop
        for I in 0 to 238 loop
          x <= CONV_STD_LOGIC_VECTOR (I, 8);
          y <= CONV_STD_LOGIC_VECTOR (J, 8);
          WAIT FOR DELAY;
          IF ( ((I*J) mod 239) /= ieee.std_logic_unsigned.CONV_INTEGER(z) ) THEN 
            write(TX_LOC,string'("ERROR!!! X=")); write(TX_LOC, x);
            write(TX_LOC,string'("* Y=")); write(TX_LOC, y);
            write(TX_LOC,string'(" mod M=239"));
            write(TX_LOC,string'(" is Z=")); write(TX_LOC, z);
            write(TX_LOC,string'(" instead of:")); write(TX_LOC, (I*J) mod 239);
            write(TX_LOC, string'(" "));
            write(TX_LOC,string'(" (i=")); write(TX_LOC, i);
            write(TX_LOC,string'(" j=")); write(TX_LOC, j); 
            write(TX_LOC, string'(")"));
            TX_STR(TX_LOC.all'range) := TX_LOC.all;
            Deallocate(TX_LOC);
            ASSERT (FALSE) REPORT TX_STR SEVERITY ERROR;
          END IF;  
          end loop;
      end loop;
    WAIT FOR DELAY;
    ASSERT (FALSE) REPORT
    "Simulation successful (not a failure).  No problems detected. "
    SEVERITY FAILURE;
   END PROCESS;

END;
